#ifndef _BIGINT_H
#define _BIGINT_H

struct bigint_node {
	unsigned long v;
	struct bigint_node *next;
};

typedef struct bigint_node *bigint;

unsigned int bigint_mod(const bigint *n, unsigned int m);

int bigint_parse(bigint *n, const wchar_t *s);

wchar_t *bigint_render(const bigint *n);

void bigint_free(bigint *n);

int bigint_zero(bigint *n);

int bigint_equal(const bigint *a, const bigint *b);

int bigint_is_zero(const bigint *n);

int bigint_copy(bigint *to, const bigint *from);

int bigint_dec(bigint *n);

int bigint_compare(const bigint *a, const bigint *b);

int bigint_add(bigint *sum, const bigint *a, const bigint *b);

int bigint_mul(bigint *product, const bigint *a, const bigint *b);

#endif
