#ifndef _ERROR_H
#define _ERROR_H

#include <stdio.h>
#include <stdlib.h>

extern const char *program_name;

#define internal_error(msg) \
do {\
	printerr("%s:%d: internal error: %s.\n", __FILE__, __LINE__, msg); \
	abort(); \
} while (0)

#define internal_assert(expr) \
do { \
	if (!(expr)) \
		internal_error("assertion failed: " #expr); \
} while (0)

int printerr(const char *fmt, ...);

#endif
