#ifndef _EVAL_H
#define _EVAL_H

#include "bigint.h"
#include "symtab.h"
#include "tree.h"

typedef struct bfloop_value bfloop_value;
struct bfloop_value {
	enum {
		BFLOOP_NONE,
		BFLOOP_NO,
		BFLOOP_YES,
		BFLOOP_INT,
	} type;
	bigint i;
};

typedef struct bfloop_proc bfloop_proc;
struct bfloop_proc {
	wchar_t *name;
	unsigned int num_params;
	wchar_t **params;
	const bfloop_node *block;
};

typedef struct bfloop_stack_frame bfloop_stack_frame;
struct bfloop_stack_frame {
	/* Is this a test, as opposed to a procedure? (Name ends in '?'.) */
	int is_test;
	bfloop_value output;
	symtab *syms;
	/* The index number of this procedure. */
	unsigned int proc_index;
	bfloop_stack_frame *next;
};

typedef struct bfloop_state bfloop_state;
struct bfloop_state {
	unsigned int num_procs;
	bfloop_proc *procs;
	bfloop_stack_frame *stack;
	/* The node of an activated QUIT or ABORT statement. */
	const bfloop_node *quit_abort_node;
};

void bfloop_state_init(bfloop_state *state);

void bfloop_state_free(bfloop_state *state);

int bfloop_eval(bfloop_state *state, const bfloop_node *tree);

#endif
