#ifndef _PARSE_H
#define _PARSE_H

#include <stdio.h>

#include "eval.h"
#include "tree.h"

#define YYSTYPE bfloop_node *

typedef struct {
	int first_line;
	int first_column;
	int last_line;
	int last_column;
	const char *filename;
} yyltype;
#define YYLTYPE yyltype

#include "bfloop.tab.h"

enum lang_mode {
	BLOOP_MODE,
	FLOOP_MODE,
};

/* Whether to return parse results line-by-line or a whole file at a time. */
enum parse_mode {
	STATEMENT_MODE,
	FILE_MODE,
};

void bfloop_set_filename(const char *filename);

enum lang_mode bfloop_set_lang_mode(enum lang_mode mode);

enum parse_mode bfloop_set_parse_mode(enum parse_mode mode);

bfloop_node *bfloop_parse(FILE *fp);

#endif
