#ifndef _TREE_H
#define _TREE_H

#include <stddef.h>

#include "bigint.h"

enum bfloop_node_type {
	NODE_NONE,
	NODE_NO,
	NODE_YES,
	NODE_INT,
	NODE_IDENT,
	NODE_CELL_REF,
	NODE_OUTPUT,
	NODE_AND,
	NODE_EQUALS,
	NODE_LESS_THAN,
	NODE_GREATER_THAN,
	NODE_ADD,
	NODE_MUL,
	NODE_ASSIGN,
	NODE_CALL,
	NODE_ABORT,
	NODE_QUIT,
	NODE_IF,
	NODE_MU_LOOP,
	NODE_LOOP,
	NODE_BLOCK,
	NODE_PROCEDURE,
	NODE_TOPLEVEL,
};

typedef struct bfloop_node bfloop_node;
struct bfloop_node {
	enum bfloop_node_type type;
	union {
		wchar_t *s;	/* For NODE_IDENT, NODE_CALL, and NODE_PROCEDURE. */
		bigint i;	/* For NODE_INT, NODE_CELL_REF, NODE_QUIT, NODE_ABORT, and NODE_BLOCK. */
	} v;
	bfloop_node *siblings;
	bfloop_node *children;
};

bfloop_node *bfloop_node_new(enum bfloop_node_type type);

void bfloop_tree_free(bfloop_node *root);

void bfloop_tree_print(const bfloop_node *root);

void bfloop_tree_reconstitute(const bfloop_node *root);

#endif
